#!/usr/bin/perl -w
#

use strict;
use warnings;
use Getopt::Long;
use File::Basename;
use Cwd qw(abs_path realpath getcwd);

my $pwd = dirname(realpath($0));


my ($hi,$car,$thrs,$out,$h);

GetOptions
(
	"hi=s" => \$hi,
	"car=s" => \$car,
	"thrs=s" => \$thrs,
	"out=s" => \$out,
	"help"	=> \$h
);


if ( $h )
{
	&help();
	exit;
}

unless ($hi and $car and $thrs and $out)
{
	print("Missing arguments. .. ¯\\_(ツ)_/¯ \n Exiting.\n");
	exit;
}

my $data_hierarchy = `cat $hi`;
my $data_legend_characteristics = `cat $car`;
my $data_legend_thrs = `cat $thrs`;



my $encoding = "utf-8";

my $html5_declaration = << "END_HTML5";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
END_HTML5

my $html5_endhead = << "END_HEAD";
  </head>
  <body>
END_HEAD

my $html5_endbody = << "END_BODY";
  </body>
</html>
END_BODY

my $encoding_declaration = << "END_ENCODING";

<meta charset="$encoding">

END_ENCODING

my $css_style_declaration = << "END_STYLE";

<style>

	.node
	{
  		cursor: pointer;
	}

	.node:hover
	{
  		stroke: #000;
  		stroke-width: 1.5px;
	}

	.node--leaf
	{
		fill: white;
	}

	.label
	{
  		font: 11px "Helvetica Neue", Helvetica, Arial, sans-serif;
  		text-anchor: middle;
  		text-shadow: 0 1px 0 #fff, 1px 0 0 #fff, -1px 0 0 #fff, 0 -1px 0 #fff;
	}

	.label,
	.node--root,
	.node--leaf
	{
  		pointer-events: none;
	}

  .table {
    border-collapse: collapse;
    border: #d0d4d5 solid 1px;
    border-spacing: 0px;
    font: 11px "Helvetica Neue", Helvetica, Arial, sans-serif;
    letter-spacing: 1px;
    line-height: 14px;
    padding: 5px;
    width: 100%;
    min-height: 100%;
    max-height: 90%;
  }


	.foreignObject_text {
  position: relative;
  text-decoration: underline;
  color: black;
  padding: 0 1px;
  transition: color ease 0.3s;
	}

</style>

END_STYLE

my $width = 960;
my $height = 960;
my $svg_declaration = << "END_SVG";

<svg width="$width" height="$height" id="fig"></svg>
<svg width="300" height="800" id="legendGroups"></svg>
<svg width="520" height="900" id="strainNamesArea"></svg>

END_SVG

my $d3_declaration = << "END_D3";

<script src="https://d3js.org/d3.v4.min.js"> </script>

END_D3

my $color_legend_characteristics = "d3.schemeCategory20";
my $color_legend_thrs = "d3.schemeCategory20b";

my $script = << "END_SCRIPT";
<script>
//******************************************************************************
// Generation of datas
//******************************************************************************
  var data_hierarchy = $data_hierarchy ;

  var data_legend = $data_legend_characteristics ;

	var data_thrs = $data_legend_thrs ;

	var data_circlepack_title = [{"title":"KI-S Circlepack"}];
	var data_thrs_title = [{"title":"Thresholds"}];
	var data_groups_title = [{"title":"Groups"}];


// Initialisation of some variable
	var svg = d3.select("#fig"),
    margin = 20,
    diameter = +svg.attr("width"),
    g = svg.append("g").attr("transform", "translate(" + diameter / 2 + "," + diameter / 2 + ")");
	var svg1 = d3.select("#legendGroups");
	var color = d3.scaleOrdinal ($color_legend_characteristics).domain(d3.range(0, 20));
	var colorPack = d3.scaleOrdinal ($color_legend_thrs).domain(d3.range(0, 9));

	// Gestion of visualization construction
	var pack = d3.pack()
 	 	.size([diameter - margin, diameter - margin])
  	.padding(2);

	var root = d3.hierarchy (data_hierarchy)
		.sum(function(d) {
			return d.size;
		})
		.sort(function(a, b) {
			return b.value - a.value;
		});

	var focus = root,
		nodes = pack(root).descendants(),
		view;

	//Generate different titles
	var circlepack_title = generate_circlepack_title(data_circlepack_title);
	var title_thrs = generate_title_thrs(data_thrs_title);
	var title = generate_title(data_groups_title);
	var legendGroups = generate_legend(data_legend);
	var legendThresholds = generate_legend_treshold(data_thrs);

	// Generate circles for each nodes generated by pack layout
	var circle = g.selectAll("circle")
		.data(nodes)
		.enter()
		.append("circle")
      // Add an unique attribute for every circle allowing to make the link between the name clicked in the list and the circle that represents it
      .attr("id", function(d) {
        return d.data.name;
      })
			.attr("class", function(d) {
				return d.parent ? d.children ? "node" : "node node--leaf" : "node node--root";
			})
			.style("fill", function(d) {
				return (!d.children ? color(d.data.color) : colorPack(d.depth));
			})
			.on("click", function(d){
				fill_area_name(d);
			});

	var text = g.selectAll("text")
		.data(nodes)
		.enter()
			.append("text")
			.attr("class", "label")
			.style("fill-opacity", function(d) {
				return d.parent === root ? 1 : 0;
			})
			.style("display", function(d) {
				return d.parent === root ? "inline" : "none";
			})
			.text(function(d) {
				return d.data.name;
			});
	var node = g.selectAll("circle,text");

	svg.style("background", color(-1))
		.data(nodes)
		.on("click", function(nodes) {
			// Reset zoom
			zoom(root);
			// Display all names in area names
			fill_area_name(nodes);
		});
		zoomTo([root.x, root.y, root.r * 2 + margin]);

// When application is loaded fill area names with all informations fromm root
fill_area_name(nodes[0]);

//******************************************************************************
// Gestion of area name
//******************************************************************************

	// Function that detects the click and will color the circle that is linked to this name. This is allowed by selecting the circle by its unique id
  function recolor_node(name_node) {
    // reset color of all circles
    d3.selectAll("circle")
			.style("fill", function(d) {
      return (!d.children ? color(d.data.color) : colorPack(d.depth));
    });
    // color clicked node
    d3.select("circle#" + name_node).style("fill", "black");
  };
/**
 * [generate_area_names generate string for area names table]
 * \@param  {[string]} the_names [ID of each nodes involved in current visualization]
 * \@return {[type]}           [SVG onject containning all line of area name table]
 */
	function generate_area_names(the_names){
		// Select right SVG to append in it
		var svg2 =  d3.select("#strainNamesArea");
		// Clear previous data
		svg2.select("foreignObject").remove();
		// Construct a SVG table of links
		var area_names = svg2
			.append("foreignObject")
				.attr("y",30)
				.attr("width",400)
				.attr("height",350)
			.append('xhtml:div')
				.attr("class","table")
				.attr("overflow-x","auto")
				.style("overflow-y","scroll")
				.append("g")
				.selectAll("g")
				.data(the_names)
				.enter()
				.append("g")
				.append('xhtml:div')
				.attr("class","foreignObject_text");
		// Add text in it
		area_names.append("text")
			.text(function(d) { return d + "\\n"})
			.style("color","steelblue")
		// Adds an event to retrieve the information from the click on one of the names in the list.
		area_names.on("click", function(d) {
			recolor_node(d);
		});
		return area_names;
	};

	function fill_area_name(d){
		// Select old title and remove old title if exist
		d3.select("#strainNamesArea_title").remove();
		// Handle with default case where all nodes need to be displayed
		var the_count = getCountsOf(d.leaves(),data_legend);
		var the_names = getNamesIn(d.leaves());
		var occurences= generate_occurences(the_count);
		// Handle with case of zoomed list to display
		if (typeof(d.data.id) !== 'undefined') {
			if (focus !== d) zoom(d), d3.event.stopPropagation();
			// d.data.id is the group ID
			// res is th last number of node's index, for example, G_1_circx_adj_50 become 50
			var res = d.data.id.substring(d.data.id.lastIndexOf('_')+1,d.data.id.length);
			var grp_title = generate_grp_title(d.data.id, d.children.length, res, d.leaves(), the_count, the_names);
		};
		// Here it s possible to generate a title for area name if wanted
		var area_names = generate_area_names(the_names);
	};

//******************************************************************************
// Generation of some titles
//******************************************************************************
	/**
	 * [generate_grp_title generate title for table of area name]
	 * \@param  {[integer]} group_id   [description]
	 * \@param  {[integer]} nbChildren [Number of sub-groups]
	 * \@param  {[integer]} res        [Percentage of similarity]
	 * \@param  {[type]} the_leaves [description]
	 * \@param  {[integer]} the_count  [description]
	 * \@param  {[type]} the_names  [description]
	 * \@return {[type]}            [description]
	 */
	function generate_grp_title(group_id, nbChildren, res, the_leaves, the_count, the_names){
		var svg2 =  d3.select("#strainNamesArea");
		var grp_title = svg2.data(group_id)
			.append("g")
			// Add an ID to title to remove it easly if it not needed
			.attr("id", "strainNamesArea_title")
			.attr("transform", function() {
				return "translate(0,15)";
			});

		grp_title.append("text")
			.attr("font-family","sans-serif")
			.attr("font-size",12)
			.text(function(d){
        return "Group '"+group_id+"' ("+nbChildren+" sub-groups). "+the_leaves.length+" individuals at "+res+"% similarity. ";
			});

		return grp_title;
	};

	/**
	 * [generate_title_thrs description]
	 * \@param  {[type]} data_thrs_title [description]
	 * \@return {[type]}                 [description]
	 */
	function generate_title_thrs(data_thrs_title){
		var svg1 = d3.select("#legendGroups");
		var title_thrs = svg1.selectAll("g")
		.data(data_thrs_title)
		.enter()
		.append("g");

		title_thrs.append("text")
			.attr("transform", function(d, i) { return "translate(20,30)"; })
			.attr("font-family","sans-serif")
			.attr("text-decoration","underline")
			.text(function(d){
				return d.title;
			});
		return title_thrs;
	};


	/**
	 * [generate_title description]
	 * \@param  {[string]} data_groups_title [string used to build title]
	 * \@return {[SVG object]}                   [description]
	 */
	function generate_title(data_groups_title){
		var svg1 = d3.select("#legendGroups");
		var title = svg1.append("g")
		.selectAll("g")
		.data(data_groups_title)
		.enter()
		.append("g")
		.attr("transform", function(d, i) {
			return "translate(20,75)";
		});

		title.append("text")
		.attr("font-family","sans-serif")
		.attr("text-decoration","underline")
		.text(function(d){
			return d.title;
		});
		return title;
	};

	/**
	 * [generate_circlepack_title description]
	 * \@param  {[type]} data_circlepack_title [description]
	 * \@return {[SVG object]}                       [SVG object containning title of circle pack graph]
	 */
	function generate_circlepack_title(data_circlepack_title) {
		var circlepack_title = svg.append("g")
			.selectAll("g")
			.data(data_circlepack_title)
			.enter()
			.append("g")
			.attr("transform", function(d, i) {
				return "translate(0,20)"; });

		circlepack_title.append("text")
			.attr("font-family","sans-serif")
			.attr("text-decoration","underline")
			.attr("font-size",20)
			.attr("font-weight","bold")
			.text(function(d){ return d.title;});
		return circlepack_title
	};
//******************************************************************************
// SVG gestion
//******************************************************************************
	/**
	 * [zoom description]
	 * \@param  {[type]} d [description]
	 * \@return {[type]}   [description]
	 */
	function zoom(d)
	{
		var focus0 = focus;
		var focus = d;

		var transition = d3.transition()
			.duration(d3.event.altKey ? 7500 : 750)
			.tween("zoom", function(d)
			{
				var i = d3.interpolateZoom(view, [focus.x, focus.y, focus.r * 2 + margin]);
				return function(t) {
					zoomTo(i(t));
				};
			});

		transition.selectAll("text")
			.filter(function(d) { return d.parent === focus || this.style.display === "inline"; })
			.style("fill-opacity", function(d) { return d.parent === focus ? 1 : 0; })
			.on("start", function(d) { if (d.parent === focus) this.style.display = "inline"; })
			.on("end", function(d) { if (d.parent !== focus) this.style.display = "none"; });
	};

	/**
	 * [zoomTo description]
	 * \@param  {[type]} v [description]
	 * \@return {[type]}   [description]
	 */
	function zoomTo(v)
	{
		var k = diameter / v[2]; view = v;
		node.attr("transform", function(d) {
			return "translate(" + (d.x - v[0]) * k + "," + (d.y - v[1]) * k + ")";
		});
		circle.attr("r", function(d) { return d.r * k; });
	}

//******************************************************************************
// Construction of legend
//******************************************************************************
	/**
	 * [generate_legend description]
	 * \@param  {[type]} data_legend [description]
	 * \@return {[type]}             [description]
	 */
	function generate_legend(data_legend){
		var svg1 = d3.select("#legendGroups");
		var legendGroups = svg1.append("g")
			.selectAll("g")
			.data(data_legend)
			.enter()
			.append("g")
			.attr("transform", function(d, i) {
				return "translate(10,100)";
			});

		legendGroups.append("rect")
			.attr("width",10)
			.attr("height",10)
			.attr("transform", function(d, i) {
				return "translate(10,"+((i*20)-20)+")";
			})
			.attr("dy", "-.20em")
			.attr("fill", function(d, i) {
				return color(d.color);
			});

		legendGroups.append("text")
			.attr("transform", function(d, i) {
				return "translate(20,"+i*20+")";
			})
			.attr("dy", "-.35em")
			.attr("font-family","sans-serif")
			.text(function(d) {
				return d.legend;
			});

		return legendGroups;
	};

	/**
	 * [generate_legend_treshold description]
	 * \@param  {[type]} data_thrs [description]
	 * \@return {[type]}           [description]
	 */
	function generate_legend_treshold(data_thrs){
    var svg1 = d3.select("#legendGroups");
		var legendThresholds = svg1.append("g")
		.selectAll("g")
		.data(data_thrs)
		.enter()
		.append("g");

		legendThresholds.append("rect")
			.attr("width",10)
			.attr("height",10)
			.attr("transform", function(d, i) {
				return "translate("+(20+(i*50))+",45)"; })
			.attr("dy", "-.20em")
			.attr("fill", function(d, i) {
				return colorPack(d.color);
			});

		legendThresholds.append("text")
			.attr("font-size",10)
			.attr("transform", function(d, i) {
				return "translate("+((20+(i*50)+15))+",55)";
			})
			.attr("dy", "-.35em")
			.attr("font-family","sans-serif")
			.text(function(d) {
				return d.threshold;
			});
		return legendThresholds;
	};

	function generate_occurences(the_count){
		var svg1 = d3.select("#legendGroups");
		// Remove old occurences text
		var occurences_to_del = d3.selectAll(".occurences").remove();
		var occurences = svg1.append("g")
			.selectAll("g")
			.data(the_count)
			.enter()
			.append("g")
			.attr("transform", function() {
				return "translate(10,100)"; });

		occurences.append("text")
			.attr("transform", function(d, i) { return "translate(250,"+(i*20)+")"; })
			.attr("dy", "-.35em")
			.attr("class", "occurences")
			.attr("font-family","sans-serif")
			.text(function(d,i) {
				if (the_count[i] !==  0) return the_count[i]
			})
		return occurences;
	};

//******************************************************************************
// Small tool functions
//******************************************************************************
	/**
	 * [getCountsOf description]
	 * \@param  {[type]} leaves [description]
	 * \@param  {[type]} groups [description]
	 * \@return {[type]}        [description]
	 */
	function getCountsOf(leaves,groups)
	{
		count = [];

		for (var i = 0; i < groups.length; ++i)
			count[i] = 0;

		for (var i = 0; i < leaves.length; ++i)
			for (var j = 0; j < groups.length; ++j)
				if (leaves[i].data.color === groups[j].color)
					count[j] += 1;

		return count;
	};

	/**
	 * [getNamesIn description]
	 * \@param  {[type]} leaves [description]
	 * \@return {[type]}        [description]
	 */
	function getNamesIn(leaves)
	{
		var names = [];
		for (var i = 0; i < leaves.length; ++i)
			names.push(leaves[i].data.name);
		return names;
	};


</script>
<p><b><a href="https://sourcesup.renater.fr/wiki/ki-s/">KI-S</a></b> : A rapid and simple method for assessing and representing genome sequence relatedness. (<a href="https://doi.org/10.24072/pcjournal.37">Peer Community Journal, Volume 1 (2021), article no. e24.</a>) </p>
END_SCRIPT


open (my $fh_output, ">$out");

print $fh_output $html5_declaration;
print $fh_output $encoding_declaration;
print $fh_output $css_style_declaration;
print $fh_output $html5_endhead;
print $fh_output $svg_declaration;
print $fh_output $d3_declaration;
print $fh_output $script;
print $fh_output $html5_endbody;
close ($fh_output);


=head2	function help

	Title			: help
	Usage			: &help()
	Function		: Displays the help 
	Returns			: none
	Args			: none


=cut

sub help
{
	print("\n");
	print(basename($0)." - Constructs the HTML file for circle packing with JSON hierarchy, JSON legend for characteristics and JSON legend for thresholds . \n"); 
	print("\n");
	print("\t-hi=\t\t<json file>\t\t\tThe input hierarchy\n");
	print("\t-car=\t\t<json file>\t\t\tThe input legend for characteristics\n");
	print("\t-thrs=\t\t<json file>\t\t\tThe input legend for thresholds\n");
	print("\t-out=\t\t<html file>\t\t\tThe output visualisation\n");
	print("\n");
	
	print("DOCUMENTATION & HELP\n\n");
	print("\t--help\t\t\t\t\t\tDisplay this help\n");
	print("\n");

	print("Example\n");
	
	print("\t>\tperl ".basename($0)." -hi=output.json -car=output_legend.json -thrs=output_legend_thrs.json -out=output.html \n\n");
}
